###########################################################################
## Talk System Data Base
###########################################################################

import Talk


###########################################################################
## Dilogos estndars
###########################################################################


## Alone: Textos que dice el player cuando no hay nadie encarado
##-------------------------------------------------------------------------

TSDB.Alone = ['No me gusta hablar solo',
              'Con quin quieres hablar?',
              'Te parece bien hablar a gritos?',
              'No pretenders que hable con las piedras?']

              

## Alone: Textos que dice el player cuando el personaje encarado
##        no tiene asignado ningn dilogo.
##-------------------------------------------------------------------------
              
TSDB.Ignore = ['No pretenders hablar con ese?',
               'Me temo que me est ignorando',
               'Eh t! Podras escucharme...']
              
###########################################################################
## Dilogos para cada personaje
###########################################################################

## Dlg Database:
## Format:
##    TSDB.Dlg [pers.Name]={
##           'dlgId': {
##              'Text':
##                """Texto libre""",
##               'Answers': ['ansId1',...'ansIdn']
##              'OtroAtributo': valor
##           }
##    }
##
## * Text: El texto ser formateado por TS.
## * Answer: Lista de respuestas (ansId). Si la lista es
##   nula [] se termina la conversacin.
## Para detalles adicionales consulta la documentacin.
##
##-------------------------------------------------------------------------

TSDB.Dlg ["Glofror"]={
	'Hola': {
	    'Text':
	     """Orcos! An ha de nacer la criatura que pueda vencer el hacha de Glofror! """\
	     """Ests bien muchacho? Uno no debe confiarse con estas bestias. Son """\
	     """estpidos pero fuertes.""",
            'Answers': ['Soy yo', 'Soy yo sin orcos', 'Dejame']
        },
	'Pues tu veras': {
	    'Text':
	     """Este no es el mejor lugar para rechazar una ayuda. En fn, ir a ver cmo """\
	     """est el viejo Elglar.""",
            'Answers': [],
	    'NewDlg': None
        },
	'Quedan orcos': {
	    'Text':
	     """Creo que an queda alguno detras de la Posada. Mi brazo est herido """\
	     """y no creo que aguante otra pelea. Ir mientras a ver al viejo Elglar.""", 
            'Answers': ['Yo me encargo','Si hay que ir se va']
        },
	'A por ellos': {
	    'Text':
	     """Por las barbas de Durin que Gondor sigue dando hombres valientes!""", 
            'Answers': [],
	    'NewDlg': 'Alguno mas'
        },
	'Si tu lo dices': {
	    'Text':
	     """Tal vez tengas razn! Pero ser dificil que te acompae. Mis horas de """\
	     """lucha han llegado a su fin. Este brazo tardar en recuperarse. """, 
            'HideDelay':20, 
            'Answers': [],
	    'NewDlg': None
        },
	'Alguno mas': {
	    'Text':
	     """Por la gloria de Aul! Sigues vivo muchacho! Has encontrado alguna bestia ms?""",
            'Answers': ['Uno grande', 'Ninguno'],
	    'NewDlg': 'Vienes de Gondor'
        },
	'Vienes de Gondor': {
	    'Text':
	     """Dol Amroth... no conozco ese lugar, pero todos los gondorianos son amigos de Glofror. """\
	     """Un poco lejos de tu tierra, no te parece?""",
            'Answers': ['Iba tras los orcos']
        },
	'Una historia extraa': {
	    'Text':
	     """Una historia extraa la que nos cuentas! Hace tiempo que no viajo por tierras de Gondor """\
	     """pero siempre me ha parecido un lugar seguro. No s qu demonios hacan esos orcos tan lejos """\
	     """del reino del Oscuro. No vamos a poder estar seguros en ningn lugar. Eh, Elglar! Recuerdas """\
	     """esa chica que pas por aqu hace unos das? Cont una historia muy parecida.""",
	    'ExtraDlg': ['Elglar',
	                 """Claro que lo recuerdo! Persegua un grupo de orcos que haban acabado """\
	                 """con su madre... Estaba desesperada y decidi ir a las montaas. Nosotros le """\
	                 """advertimos... y de esto hace ya ms de tres lunas."""],
	     'CallBack':'UnPocoDeMusicaON', 
            'Answers': ['SoyElla', 'Montaas']
	},
	'Lord': {
	    'Text':
	     """No lo s ni quiero saberlo. Eran muchos los comerciantes que hacan la ruta del rio Gwathlo """\
	     """pero en estos das pocos son los que se aventuran por el desfiladero. Hace unas semanas """\
	     """Lord Adrinnor intent esa ruta y tuvo que regresar.""",
            'Answers': ['SoyElla','Qu pas']
	},
	'Puente roto': {
	    'Text':
	     """Segn nos cont, el camino est plagado de bestias. Enormes orcos sedientos de sangre. """\
	     """Lord Adrinnor y su escolta consiguieron llegar hasta el Alto de Sevarel, pero dicen """\
	     """que el puente est destruido y las aguas del Gwathlo son muy traicioneras en estas fechas.""",
	     'CallBack':'UnPocoDeMusicaOFF', 
            'Answers': ['SoyElla']
	},
	'Me temo que no': {
	    'Text':
	     """Me temo que no, pero creo que vena de Minhiriath. He viajado mucho pero qu me aspen """\
	     """si s dnde queda ese lugar! Pero si todos sus habitantes son iguales creo que va siendo hora """\
	     """de hacerles una visita de cortesa, T que dices Elglar?""",
	    'ExtraDlg': ['Elglar',
	                 """Estoy pensando en llevarme la posada... con tanta bestia por aqu..."""],
            'Answers': ['Montaas'],
	    'ReplaceAns':{'Montaas':['Qu pas']},
	    'NewDlg': None
	},
	'Mas datos': {
	    'Text':
	     """No pienses mal de m, %PlayerName. Ese viajero insentato era un necio arrogante pero yo no lo ahogu. """\
	     """Al ver las cascadas del rio empez a dar saltos de alegra y se fue hacia ellas como """\
	     """un poseso. Supongo que las aguas del Gwathlo haran el resto...""",
            'HideDelay':30, 
            'Answers': [],
	    'NewDlg': None
        }
}



###########################################################################
## Player Answers
###########################################################################

## Answers Database:
## Format:
##   TSDB.Ans [pers.Name]={
##	'ansId': {
##	    'Text':
##	     """Texto""",
##	    'NextDlg': 'ansId',
##	    'Enabled':1
##          'OtroAtributo': valor
##       }
##    }
## * Text: El texto ser formateado por TS.
## * NextDlg: El identificador del siguiente dilogo (dlgId). Para
##   terminar la conversacin: None.
## Para detalles adicionales consulta la documentacin.
##-------------------------------------------------------------------------



TSDB.Ans ["Glofror"]={
	'Soy yo': {
	    'Text':
	     """Lo cierto es que estos no parecan muy estpidos! Mi nombre es Damathar, """\
	     """hijo de Othar, soldado gondoriano en Dol Amroth. Gracias por ayudarme.""",
	    'NextDlg': 'Quedan orcos',
	    'Enabled':1
        },
	'Soy yo sin orcos': {
	    'Text':
	     """Lo cierto es que estos no parecan muy estpidos! Mi nombre es Damathar, """\
	     """, hijo de Othar, soldado gondoriano en Dol Amroth. Gracias por ayudarme.""",
	    'NextDlg': 'No quedan orcos',
	    'Enabled':0
        },
	'Dejame': {
	    'Text':
	     """Djame en paz! S cuidarme slo.""",
	    'NextDlg': 'Pues tu veras',
	    'Enabled':1
        },
	'Yo me encargo': {
	    'Text':
	     """No te preocupes Glofror, echar un vistazo al establo y enseguida me reuno """\
	     """con vosotros.""",
	    'Journal': 'BuscaOrco',
	    'NextDlg': 'A por ellos',
	    'Enabled':1
        },
	'Si hay que ir se va': {
	    'Text':
	     """Mejor te acompao a la Posada. No creo que sea buena idea salir slo.""",
	    'NextDlg': 'Si tu lo dices',
	    'Enabled':1
        },
	'Uno grande': {
	    'Text':
	     """El Orco ms grande que he visto en mi vida! Qu Ilvatar nos protega! """\
	     """Esas bestias no deberan existir.""",
	    'NextDlg': 'Vienes de Gondor',
	    'Enabled':1
        },
	'Ninguno': {
	    'Text':
	     """No he visto nada. Tal vez se hayan retirado a las montaas.""",
	    'NextDlg': 'Vienes de Gondor',
	    'Enabled':1
        },
	'Iba tras los orcos': {
	    'Text':
	     """Hace unos das un grupo de orcos atac la granja de mi padre. No pude evitar """\
	     """su muerte pero pude seguirles el rastro. Creo que son los que han atacado la Posada.""",
	    'NextDlg': 'Una historia extraa',
	    'Enabled':1
        },
	'SoyElla': {
	    'Text':
	     """Esa chica... dijo su nombre?""",
	    'NextDlg': 'Me temo que no',
	    'Enabled':1
        },
	'Montaas': {
	    'Text':
	     """Qu ocurre en las montaas?""",
	    'NextDlg': 'Lord',
	    'Enabled':1
        },
	'Qu pas': {
	    'Text':
	     """Por qu regres Lord Adrinnor?""",
	    'NextDlg': 'Puente roto',
	    'Enabled':1
        }
}

###########################################################################
## Journal
###########################################################################

TSDB.JrlTxt = {
	'BuscaOrco':
	    """Glofror me ha pedido que mire detrs de la posada. Parece que """\
	    """an pueden quedar orcos por ah."""
        }
